// Licensed Materials - Property of HCL
// (C) Copyright HCL Technologies Ltd. 2021.  All Rights Reserved.
//
// Note to U.S. Government Users Restricted Rights:
// Use, duplication or disclosure restricted by GSA ADP Schedule Contract

var objShell = WScript.CreateObject("WScript.Shell");
var fso = WScript.CreateObject("Scripting.FileSystemObject");

var UserProfile = objShell.ExpandEnvironmentStrings("%USERPROFILE%");
var cteProcess = "ctexplorer.exe";
// This needs to be branded for HCL in the HCL stream. .Rational -> .hcl
var dir = fso.BuildPath(UserProfile, ".Rational");

if(!fso.FolderExists(dir)) {
  fso.CreateFolder(dir);    
}

try {
    var objArgs = WScript.Arguments;
    var file = fso.BuildPath(dir, "parameters.handler");
    var fh = fso.CreateTextFile(file, true);
    var text = "";
    for (i = 0; i < objArgs.length; i++) {
        if(i == 0) {
            text = objArgs.item(i);
        } else {
            text += " " + objArgs.item(i);
        }
    }
    fh.WriteLine(text);
    fh.Close();
} catch(e) {
    objShell.Popup("ERROR: Unable to write to " + file + ": " + e.message);
    WScript.quit();
}

// Start CTE if it is not running
var Found = false;
var TempDir = objShell.ExpandEnvironmentStrings("%TEMP%");
var TempFile = fso.BuildPath(TempDir, fso.GetTempName());
objShell.Run("%ComSpec% /c tasklist /NH /FO CSV /FI \"IMAGENAME eq "+cteProcess+"\" /FI \"USERNAME eq %USERNAME%\" >" + TempFile, 7, true);
var objTextFile = fso.OpenTextFile(TempFile, 1);
do {
    var strText = objTextFile.ReadLine().toLowerCase();
    if(strText.indexOf(cteProcess) >= 0) {
        Found = true;
    }
} while(!objTextFile.AtEndOfStream);
objTextFile.Close();
fso.DeleteFile(TempFile);

if(!Found) {
  rundir = fso.GetParentFolderName(WScript.ScriptFullName);
  cte = "\"" + fso.BuildPath(rundir, cteProcess) + "\"";
  objShell.Run(cte, 1);
}
