<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--<xsl:output
  indent="yes"/> -->
<xsl:output method="xml" indent="yes"/>  
<xsl:template match="/">
<xform xmlns:xf="http://www.w3.org/2002/xforms" 
       xmlns="http://www.w3.org/1999/xhtml"  
       xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
       xmlns:ev="http://www.w3.org/2001/xml-events"
       xmlns:cq="http://clearquest">  
<!-- process the data model first -->
        

    <xf:model id="data-model">    
      <xsl:element name="xf:instance">
        <xsl:attribute name="id">model-instance</xsl:attribute>
        <xsl:element name="root-instance">
        <xsl:for-each select="mForm">        
        <xsl:for-each select="mFormPage">   
          <xsl:for-each select="mFormItem">   
            <xsl:call-template name="createModelElement"/>
          </xsl:for-each>  <!-- End of for-each item -->       
        </xsl:for-each>  <!-- End of for-each page -->
        </xsl:for-each>  <!-- End of for-each form -->      
      </xsl:element>  
      </xsl:element>
        <!-- Bind the data elements -->  
      <!--
      <xsl:for-each select="mForm">
       <xsl:for-each select="mFormPage">   
         <xsl:for-each select="mFormItem">   
           <xsl:call-template name="createBind"/>
         </xsl:for-each>         
       </xsl:for-each>        
      </xsl:for-each>             
      -->
    </xf:model>

  

<!-- Create the ui controls -->
  <xsl:for-each select="mForm">
    <xsl:element name="body">
      <!-- process the form -->      
      <xsl:attribute name="style">position:absolute</xsl:attribute> 
      <xsl:element name="xf:switch">
        <xsl:call-template name="processForm"/>
        <xsl:attribute name="ref">cqswitch</xsl:attribute> 
        <xsl:attribute name="id">
       		cqswitch
        </xsl:attribute>           
        <xsl:for-each select="mFormPage">           
          <xsl:element name="xf:case">
            <xsl:attribute name="id"><xsl:value-of select="caption"/></xsl:attribute>
            <xsl:attribute name="selected">true</xsl:attribute>
            <xsl:call-template name="processAbsoluteCoordinates"/>
          <!-- process each page -->      
            <!-- process each item on page -->
            <xsl:for-each select="mFormItem">                                            
               <xsl:call-template name="processControl"/>                                       
            </xsl:for-each>          
          </xsl:element>
        </xsl:for-each>  <!-- end of page processing -->
      </xsl:element>  <!-- end of switch  -->
    </xsl:element>  <!-- end of body element  -->
  </xsl:for-each>          
</xform>

</xsl:template>

<xsl:template name="processControl" xmlns:xf="http://www.w3.org/2002/xforms">
            <xsl:if test="@itemType=0">
            	<xsl:call-template name="processButton"/>
            </xsl:if>
            <!--Static Text-->
            <xsl:if test="@itemType=1">
            	<xsl:call-template name="processStaticText"/>
            </xsl:if>
            
            <!-- Text boxes -->
              <xsl:if test="@itemType=2"> 
                <xsl:variable name="isMultiLine" select="isMultiLine"/>
				<xsl:variable name="isPassword" select="isPassword"/>				
              	<xsl:choose>
              	  <xsl:when test="$isMultiLine=1">
              	  	<xsl:call-template name="processTextArea"/>
              	  </xsl:when>
				  <xsl:when test="$isPassword=1">
					<xsl:call-template name="processPasswordField"/>
				  </xsl:when>
				  <xsl:otherwise>
              	  	<xsl:variable name="isDateCode" select="formDate/dateCode"/>
              	  	<xsl:variable name="isTimeCode" select="formDate/timeCode"/>
              	  	<xsl:choose>
	              	  	<xsl:when test="$isDateCode>0 or $isTimeCode>0">
    	          	  		<xsl:call-template name="processDateTimeField"/>
        				</xsl:when>
        				<xsl:otherwise>
		              	  	<xsl:call-template name="processTextField"/>
		              	</xsl:otherwise>
		            </xsl:choose>
              	  </xsl:otherwise>
              	</xsl:choose>                                                                                                                                         
              </xsl:if>    
              
            <!-- Groups -->            
            <xsl:if test="@itemType=3">                        
                <xsl:call-template name="processGroup"/>                                                
            </xsl:if>
            
            <!-- Checkbox -->
            <xsl:if test="@itemType=4">
            	<xsl:call-template name="processCheck"/>
            </xsl:if>
            
            <!--Radio Group-->
            <xsl:if test="@itemType=5">
            	<xsl:call-template name="processRadioGroup"/>
            </xsl:if>
            
            <!--Radio-->
            <xsl:if test="@itemType=6">
            	<xsl:call-template name="processRadio"/>
            </xsl:if>
            
            <!-- List boxes -->
            <xsl:if test="@itemType=7">
                <xsl:call-template name="processListBox"/>                                                              
            </xsl:if>
            
            <!-- Old Style Open Combo -->
            <xsl:if test="@itemType=8">
            	<xsl:call-template name="processOpenCombo"/>
            </xsl:if>
            
            <!-- Combos -->
            <xsl:if test="@itemType=9">                           
                <xsl:call-template name="processComboBox"/>     
            </xsl:if>
            
            <!-- Drop List box - closed choices -->

            <xsl:if test="@itemType=10">
              <xsl:call-template name="processDropList"/>
            </xsl:if>
            
            <!-- Ref Table -->
            <xsl:if test="@itemType=12">
            	<xsl:call-template name="processTable"/>
            </xsl:if>
            
            <xsl:if test="@itemType=20">
              <xsl:call-template name="processHistory"/>
            </xsl:if>  
            
            <xsl:if test="@itemType=21">
              <xsl:call-template name="processAttachment"/>
            </xsl:if>  
            
			<xsl:if test="@itemType=22">
			  <xsl:call-template name="processDuplicateBase"/>
			</xsl:if>
			
			<xsl:if test="@itemType=23">
			  <xsl:call-template name="processDuplicateList"/>
			</xsl:if>

</xsl:template>



<xsl:template name="processForm">
  <xsl:call-template name="processAbsoluteCoordinates"/>
<!--   <xsl:attribute name="style">position:absolute</xsl:attribute>  -->
</xsl:template>

<xsl:template name="processFormPage">

  <xsl:call-template name="processLabelNoPosition"/> 
  <!--
  <xsl:attribute name="label">
    <xsl:value-of select="caption"/>
  </xsl:attribute>
  -->
</xsl:template>

<xsl:template name="createBind" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:if test="string-length(fieldSource) &gt; 0">
  <xsl:element name="xf:bind">                      
    <xsl:attribute name="id"><xsl:value-of select="fieldSource"/></xsl:attribute>
    <xsl:attribute name="nodeset"><xsl:text>instance('model-instance')/</xsl:text><xsl:text>_</xsl:text><xsl:value-of select="generate-id(fieldSource)"/></xsl:attribute>
  </xsl:element>
</xsl:if> 
</xsl:template>

<xsl:template name="createModelElement" xmlns:xf="http://www.w3.org/2002/xforms">
    <!-- We need to ignore ActiveX(13) controls -->
	<xsl:if test="@itemType!=13">
		<xsl:variable name="fieldSource"> 
			<xsl:text>_</xsl:text><xsl:value-of select="generate-id(fieldSource)"/> 
		</xsl:variable>                               
		<xsl:element name="{$fieldSource}"/>
	</xsl:if>	  
	<xsl:if test="@itemType=20">
		<xsl:element name="history"/>
	</xsl:if>
	
	<xsl:if test="@itemType=22">
		<xsl:element name="CQDuplicateBase"/>
	</xsl:if>
	
	<xsl:if test="@itemType=23">
		<xsl:element name="CQDuplicateList"/>
	</xsl:if>
	<xsl:if test="@itemType=3">
		<xsl:for-each select="item">                                            
    		<xsl:for-each select="mFormItem">                                            
     			<xsl:call-template name="createModelElement"/>                                       
    		</xsl:for-each>  
  		</xsl:for-each>
  	</xsl:if>  
</xsl:template>
<!--
<xsl:template name="processGroupForModel" xmlns:xf="http://www.w3.org/2002/xforms">
  <xsl:for-each select="item">                                            
    <xsl:for-each select="mFormItem">                                            
     <xsl:call-template name="processControl"/>                                       
    </xsl:for-each>  
  </xsl:for-each>  
</xsl:template>

<xsl:template name="processGroupForBind" xmlns:xf="http://www.w3.org/2002/xforms">
  <xsl:for-each select="item">                                            
    <xsl:for-each select="mFormItem">                                            
     <xsl:call-template name="createBind"/>                                       
    </xsl:for-each>  
  </xsl:for-each>  
</xsl:template>
-->

<!-- Processes a caption that has no coordinates -->
<xsl:template name="processLabelNoPosition">
  <xsl:element name="label">
    <xsl:value-of select="caption"/>
  </xsl:element>
</xsl:template>

<xsl:template name="processGroup" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:group">   
  <xsl:attribute name="style">
    <xsl:text>position:absolute;</xsl:text>
    <xsl:text>left: </xsl:text><xsl:value-of select="number(@x * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>top: </xsl:text><xsl:value-of select="number(@y * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>width: </xsl:text><xsl:value-of select="number(@width * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>height: </xsl:text><xsl:value-of select="number(@height * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>border-style:solid;</xsl:text>
    <xsl:text>border-width:1;</xsl:text>
  </xsl:attribute>
  <xsl:call-template name="processLabelNoPosition"/>
  <xsl:for-each select="item">                                            
    <xsl:for-each select="mFormItem">                                            
		<xsl:call-template name="processControl"/>
    </xsl:for-each>  
  </xsl:for-each>  

</xsl:element>            


</xsl:template>

<!-- adds the absolute positioned attributes to a control's style -->
<xsl:template name="processAbsoluteCoordinates">
  <xsl:attribute name="style">
    <xsl:text>position:absolute;</xsl:text>
    <xsl:text>left: </xsl:text><xsl:value-of select="number(@x * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>top: </xsl:text><xsl:value-of select="number(@y * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>width: </xsl:text><xsl:value-of select="number(@width * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>height: </xsl:text><xsl:value-of select="number(@height * 1.75)"/><xsl:text>;</xsl:text>
    <!--<xsl:text>border-style:solid;</xsl:text>-->
  </xsl:attribute>            
</xsl:template>

<!-- adds the absolute positioned attributes to a control's style -->
<xsl:template name="processAbsoluteCoordinatesWithVScroll">
  <xsl:attribute name="style">
    <xsl:text>position:absolute;</xsl:text>
    <xsl:text>left: </xsl:text><xsl:value-of select="number(@x * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>top: </xsl:text><xsl:value-of select="number(@y * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>width: </xsl:text><xsl:value-of select="number(@width * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>height: </xsl:text><xsl:value-of select="number(@height * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>vscroll;</xsl:text>
  </xsl:attribute>            
</xsl:template>

<!-- Adds attributes that are common to every control -->
<xsl:template name="processBaseControl">
  <xsl:call-template name="processAbsoluteCoordinates"/>
  <!--
  <xsl:attribute name="bind">
    <xsl:value-of select="fieldSource"/>
  </xsl:attribute>  
  -->
  <xsl:variable name="field" select="fieldSource"/>	
  <xsl:attribute name="ref">
    <xsl:if test="$field!=''">
      <xsl:text>_</xsl:text><xsl:value-of select="generate-id(fieldSource)"/>
    </xsl:if>
  </xsl:attribute> 
  <xsl:attribute name="title">
    <xsl:if test="$field!=''">
      <xsl:text>_</xsl:text><xsl:value-of select="fieldSource"/>
    </xsl:if>
  </xsl:attribute>    
  <xsl:attribute name="id">
    <xsl:value-of select="generate-id(fieldSource)"/>
  </xsl:attribute>  
  <xsl:attribute name="tabOrder">
    <xsl:value-of select="tabOrder"/>
  </xsl:attribute>                 
  <xsl:attribute name="incremental">true</xsl:attribute>
</xsl:template>

<xsl:template name="processBaseNoRefControl">
  <xsl:call-template name="processAbsoluteCoordinates"/>
  <xsl:attribute name="id">
    <xsl:value-of select="generate-id(caption)"/>
  </xsl:attribute>  
  <xsl:attribute name="tabOrder">
    <xsl:value-of select="tabOrder"/>
  </xsl:attribute>                 
  <xsl:attribute name="incremental">true</xsl:attribute>
</xsl:template>

<!-- Add the labels coordinates and name to the current element in the result set -->
<xsl:template name="processLabel" xmlns:xf="http://www.w3.org/2002/xforms">
  <xsl:element name="xf:label">
      <xsl:attribute name="style">
        <xsl:text>position: absolute;</xsl:text>
        <xsl:text>left: </xsl:text><xsl:value-of select="number(captionRect/@x * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>top: </xsl:text><xsl:value-of select="number(captionRect/@y * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>width: </xsl:text><xsl:value-of select="number(captionRect/@width * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>height: </xsl:text><xsl:value-of select="number(captionRect/@height * 1.75)"/><xsl:text>;</xsl:text>         
      </xsl:attribute>    
      <xsl:value-of select="caption"/>
  </xsl:element>    
</xsl:template>

<!-- Add the labels coordinates and name to the current element in the result set -->
<xsl:template name="processLabelWithCenterAlignment" xmlns:xf="http://www.w3.org/2002/xforms">
  <xsl:element name="xf:label">
      <xsl:attribute name="style">
        <xsl:text>position: absolute;</xsl:text>
        <xsl:text>left: </xsl:text><xsl:value-of select="number(captionRect/@x * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>top: </xsl:text><xsl:value-of select="number(captionRect/@y * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>width: </xsl:text><xsl:value-of select="number(captionRect/@width * 1.75)"/><xsl:text>;</xsl:text>
        <xsl:text>height: </xsl:text><xsl:value-of select="number(captionRect/@height * 1.75)"/><xsl:text>;</xsl:text>         
        <xsl:text>text-align: center;</xsl:text>
      </xsl:attribute>    
      <xsl:value-of select="caption"/>
  </xsl:element>    
</xsl:template>


<!-- Process the text field element -->
<xsl:template name="processTextField" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:input">  
  <xsl:call-template name="processBaseControl"/>
  <xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<xsl:template name="processPasswordField" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:secret">  
  <xsl:call-template name="processBaseControl"/>
  <xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<!-- Process the DateTime field element -->
<xsl:template name="processDateTimeField" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:input">  
  <xsl:call-template name="processBaseControl"/>
  <xsl:attribute name="CQDateTime">true</xsl:attribute>
  <xsl:attribute name="DateCode"><xsl:value-of select="formDate/dateCode"/></xsl:attribute>
  <xsl:attribute name="TimeCode"><xsl:value-of select="formDate/timeCode"/></xsl:attribute>
  <xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<!-- Process a multi-line text field element -->
<xsl:template name="processTextArea" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:textarea">  
  <xsl:call-template name="processBaseControl"/>
  <xsl:attribute name="style">
    <xsl:text>position:absolute;</xsl:text>
    <xsl:text>left: </xsl:text><xsl:value-of select="number(@x * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>top: </xsl:text><xsl:value-of select="number(@y * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>width: </xsl:text><xsl:value-of select="number(@width * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>height: </xsl:text><xsl:value-of select="number(@height * 1.75)"/><xsl:text>;</xsl:text>
    <xsl:text>vscroll-bar: </xsl:text><xsl:value-of select="boolean(number(isVScrollbar))"/><xsl:text>;</xsl:text>  
    <xsl:text>hscroll-bar: </xsl:text><xsl:value-of select="boolean(number(isHScrollbar))"/><xsl:text>;</xsl:text>
    <xsl:text>overflow: wrap;</xsl:text>
  </xsl:attribute>  
  <xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<!-- Process the combo box element - ITEM=9  -->
<xsl:template name="processComboBox" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processBaseControl"/>  
  <xsl:attribute name="autoSort">                 
    <xsl:value-of select="boolean(number(isAutoSort))"/>
  </xsl:attribute>
  <xsl:attribute name="appearance">minimal</xsl:attribute>
  <xsl:attribute name="selection">open</xsl:attribute>
  <xsl:attribute name="CQCombo">true</xsl:attribute>
  <xsl:attribute name="choices">open</xsl:attribute>
    <xsl:attribute name="webDependentFields">
	  <xsl:for-each select="webDependentFields">
		<xsl:value-of select="."/>
		<xsl:text>,</xsl:text>
	  </xsl:for-each>
  </xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>
</xsl:template>

<!-- Process the combo box element - ITEM=10  -->
<xsl:template name="processDropList" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processBaseControl"/>  
  <xsl:attribute name="autoSort">                 
    <xsl:value-of select="boolean(number(isAutoSort))"/>
  </xsl:attribute>
  <xsl:attribute name="appearance">minimal</xsl:attribute>                                                                                      
  <xsl:attribute name="selection">open</xsl:attribute>
  <xsl:attribute name="CQCombo">true</xsl:attribute>          
  <xsl:attribute name="choices">closed</xsl:attribute>
  <xsl:attribute name="webDependentFields">
	  <xsl:for-each select="webDependentFields">
		<xsl:value-of select="."/>
		<xsl:text>,</xsl:text>
	  </xsl:for-each>
  </xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>
</xsl:template> 

<!-- Process the open combo box element - ITEM=8 -->
<xsl:template name="processOpenCombo" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processBaseControl"/>  
  <xsl:attribute name="autoSort">                 
    <xsl:value-of select="boolean(number(isAutoSort))"/>
  </xsl:attribute>                                                                                     
  <xsl:attribute name="selection">open</xsl:attribute>
  <xsl:attribute name="CQOpenCombo">true</xsl:attribute>          
  <xsl:call-template name="processLabel"/>     
</xsl:element>
</xsl:template> 

<!-- Process List boxes - ITEM=7  -->
<xsl:template name="processListBox" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processBaseControl"/> 
	<xsl:call-template name="processAbsoluteCoordinatesWithVScroll"/>
  <xsl:attribute name="autoSort">                 
    <xsl:value-of select="boolean(number(isAutoSort))"/>
  </xsl:attribute>
    <xsl:attribute name="appearance">compact</xsl:attribute>                                                                                      
    <xsl:attribute name="selection">open</xsl:attribute>
    <xsl:attribute name="choices">closed</xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>              
</xsl:template>

<!-- Process the reference table element - ITEM=12 -->
<xsl:template name="processTable" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processAbsoluteCoordinates"/>
  <xsl:variable name="field" select="fieldSource"/>	
  <xsl:attribute name="ref">
    <xsl:if test="$field!=''">
      <xsl:text>_</xsl:text><xsl:value-of select="generate-id(fieldSource)"/>
    </xsl:if>
  </xsl:attribute>
  <xsl:attribute name="title">
    <xsl:if test="$field!=''">
      <xsl:text>_</xsl:text><xsl:value-of select="fieldSource"/>
    </xsl:if>
  </xsl:attribute>  
  <xsl:attribute name="id">
    <xsl:value-of select="generate-id(fieldSource)"/>
  </xsl:attribute>     
	<xsl:attribute name="CQReference">true</xsl:attribute>
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="choices">closed</xsl:attribute>
	<xsl:attribute name="tabOrder">
		<xsl:value-of select="tabOrder"/>
	</xsl:attribute>
	<xsl:attribute name="tableWidth">
		<xsl:value-of select="@width * 1.75"/>
	</xsl:attribute>
	<xsl:call-template name="processLabel"/>	
	<xsl:for-each select="button">
		<xsl:element name="xf:button">
			<xsl:attribute name="caption">
				<xsl:value-of select="mFormItem/caption"/>
			</xsl:attribute>
			<xsl:attribute name="x">
				<xsl:value-of select="number(mFormItem/@x * 1.75)"/>
			</xsl:attribute>
			<xsl:attribute name="y">
				<xsl:value-of select="number(mFormItem/@y * 1.75)"/>
			</xsl:attribute>
			<xsl:attribute name="width">
				<xsl:value-of select="number(mFormItem/@width * 1.75)"/>
			</xsl:attribute>
			<xsl:attribute name="height">
				<xsl:value-of select="number(mFormItem/@height * 1.75)"/>
			</xsl:attribute>
			<xsl:attribute name="tabOrder">
				<xsl:value-of select="mFormItem/tabOrder"/>
			</xsl:attribute>
			<xsl:attribute name="btnType">
				<xsl:value-of select="mFormItem/btnType"/>
			</xsl:attribute>
			<xsl:attribute name="preClickHook">
				<xsl:value-of select="mFormItem/preClickHook"/>
			</xsl:attribute>
  			<xsl:attribute name="postClickHook">
  				<xsl:value-of select="mFormItem/postClickHook"/>
  			</xsl:attribute>
		</xsl:element>
	</xsl:for-each>
	<xsl:for-each select="columnInfo">
		<xsl:element name="xf:column">
			<xsl:attribute name="widthInPercent">
				<xsl:value-of select="number(widthInPercent)"/>
			</xsl:attribute>
			<xsl:attribute name="fieldPath">
				<xsl:value-of select="fieldPath"/>
			</xsl:attribute>
			<xsl:attribute name="label">
				<xsl:value-of select="fieldLabel"/>
			</xsl:attribute>
			<xsl:attribute name="completeFieldPath">
				<xsl:value-of select="completeFieldPath"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:for-each>
</xsl:element>
</xsl:template>

<!-- Process List boxes - ITEM=20  -->
<xsl:template name="processHistory" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:attribute name="id">
    <xsl:value-of select="generate-id(caption)"/>
  </xsl:attribute>  
  <xsl:attribute name="ref">history</xsl:attribute>
  <xsl:attribute name="title">history</xsl:attribute>
  <!--<xsl:call-template name="processBaseControl"/> -->
  <xsl:call-template name="processAbsoluteCoordinatesWithVScroll"/>                                                                                
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="choices">closed</xsl:attribute>
	<xsl:attribute name="CQHistory">true</xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>              
</xsl:template>


<!-- Process Attachment - ITEM=21  -->
<xsl:template name="processAttachment" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:call-template name="processBaseControl"/>
  <xsl:call-template name="processAbsoluteCoordinatesWithVScroll"/>                                                                                
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="choices">closed</xsl:attribute>
	<xsl:attribute name="CQAttachment">true</xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>              
</xsl:template>

<!-- Process Button - ITEM=0  -->
<xsl:template name="processButton" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:trigger">
  <xsl:call-template name="processBaseControl"/>
  <xsl:call-template name="processAbsoluteCoordinates"/>     
  <xsl:attribute name="preClickHook"><xsl:value-of select="preClickHook"/></xsl:attribute>
  <xsl:attribute name="postClickHook"><xsl:value-of select="postClickHook"/></xsl:attribute>
  <xsl:attribute name="btnType"><xsl:value-of select="mFormItem/btnType"/></xsl:attribute>  
  <xsl:attribute name="CQButton">true</xsl:attribute>                                                                         
  <xsl:call-template name="processLabelWithCenterAlignment"/>
</xsl:element>              
</xsl:template>

<!-- Process List boxes - ITEM=22  -->
<xsl:template name="processDuplicateBase" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:input">
  <xsl:call-template name="processBaseControl"/>                                                                                
  <xsl:attribute name="ref">CQDuplicateBase</xsl:attribute>
  <xsl:attribute name="title">CQDuplicateBase</xsl:attribute>
  <xsl:attribute name="CQDuplicateBase">true</xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>              
</xsl:template>

<!-- Process List boxes - ITEM=23  -->
<xsl:template name="processDuplicateList" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
  <xsl:attribute name="id">
    <xsl:value-of select="generate-id(caption)"/>
  </xsl:attribute>  
  <xsl:attribute name="ref">CQDuplicateList</xsl:attribute>
  <xsl:attribute name="title">CQDuplicateList</xsl:attribute>
  <!--<xsl:call-template name="processBaseControl"/> -->
  <xsl:call-template name="processAbsoluteCoordinatesWithVScroll"/>                                                                                
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="choices">closed</xsl:attribute>	
	<xsl:attribute name="CQDuplicateList">true</xsl:attribute>
  <xsl:call-template name="processLabel"/>     
</xsl:element>              
</xsl:template>

<!-- Process Checkbox - ITEM=4 -->
<xsl:template name="processCheck" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
	<xsl:call-template name="processBaseControl"/>
    <xsl:call-template name="processAbsoluteCoordinates"/>
  	<xsl:attribute name="CheckedValue"><xsl:value-of select="value"/></xsl:attribute>
    <xsl:attribute name="UncheckedValue"><xsl:value-of select="unCheckedValue"/></xsl:attribute>  
  	 <xsl:attribute name="selection">open</xsl:attribute>
	 <!--<xsl:attribute name="appearance">ibmforms:checkbox</xsl:attribute>-->
	 <xsl:attribute name="CQCheckBox">true</xsl:attribute>
	 <xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<!-- Process Radio - ITEM=5 -->
<xsl:template name="processRadioGroup" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
	<xsl:call-template name="processBaseControl"/>
	<xsl:call-template name="processAbsoluteCoordinates"/>
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="CQRadioGroup">true</xsl:attribute>
	<xsl:attribute name="groupName"><xsl:value-of select="@name"/></xsl:attribute>
	<xsl:call-template name="processLabel"/>
</xsl:element>
	 <xsl:for-each select="optButton">                                            
		<xsl:for-each select="mFormItem">                                            
			<xsl:call-template name="processControl"/>
		</xsl:for-each>  
	</xsl:for-each>  

</xsl:template>

<!-- Process Radio - ITEM=6 -->
<xsl:template name="processRadio" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:select1">
	<xsl:call-template name="processBaseControl"/>
	<xsl:call-template name="processAbsoluteCoordinates"/>
	<xsl:attribute name="selection">open</xsl:attribute>
	<xsl:attribute name="CQRadio">true</xsl:attribute>
	<xsl:attribute name="groupName"><xsl:value-of select="grpName"/></xsl:attribute>
	<xsl:attribute name="value"><xsl:value-of select="value"/></xsl:attribute>
	<xsl:call-template name="processLabel"/>
</xsl:element>
</xsl:template>

<!-- Process Static Text - ITEM=1 -->
<xsl:template name="processStaticText" xmlns:xf="http://www.w3.org/2002/xforms">
<xsl:element name="xf:input">
		<xsl:call-template name="processBaseNoRefControl"/>
		<xsl:variable name="fieldSource" select="fieldSource"/>
		<xsl:choose>
			<xsl:when test="$fieldSource!=''">
				<xsl:attribute name="ref"><xsl:text>_</xsl:text><xsl:value-of select="generate-id(fieldSource)"/></xsl:attribute>
				<xsl:attribute name="title">CQLABEL</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="ref">CQLABEL</xsl:attribute>
				<xsl:attribute name="title">CQLABEL</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:attribute name="CQLabel">true</xsl:attribute>
		<xsl:call-template name="processAbsoluteCoordinates"/>
		<xsl:value-of select="caption"/>
</xsl:element>
</xsl:template>


</xsl:stylesheet>