:: Licensed Materials - Property of IBM and/or HCL
:: (C) Copyright IBM Corp. 2012, 2016.  All Rights Reserved.
:: (C) Copyright HCL Technologies Ltd. 2016, 2023.  All Rights Reserved.
:: US Government Users Restricted Rights
:: Use, duplication or disclosure restricted by GSA ADP Schedule Contract
@echo off

setLocal EnableDelayedExpansion

set CMD=%~n0%

:: Store the actual path to rcleartool
set PATH_TO_RCLEARTOOL=%~dp0

:: Accept overrides from the values provided at install time
::  allows any rcleartool.bat to run any rcleartool version based 
::  on local environment variable overrides.

if not defined _JAVACMD set _JAVACMD=_JAVA_CMD_PATH_

if not exist "%_JAVACMD%" (
    echo %CMD%: ERROR: The path to java has not been configured. You must configure it manually.
    exit /B 99
)

goto :continue

:: Note - this has to be at the beginning of the file.
:setup
cd "%PATH_TO_RCLEARTOOL%"
if not exist eclipsec.exe (
    echo %CMD%: ERROR: rcleartool must be installed in the root of the eclipse installation.
    exit /B 97
)
.\eclipsec -nosplash -application com.ibm.rational.ccrc.cli.CliConfigureApplication
exit /B %ERRORLEVEL%
goto :EOF

:continue

if x%1%==xsetup (
    goto :setup
)

if not defined RCLEARTOOL_HOME set RCLEARTOOL_HOME=_CCRC_CLI_PATH_

if not defined JARS_DIR set JARS_DIR=_TEAM_API_PATH_

if not defined ORG_APACHE_XML_PATH set ORG_APACHE_XML_PATH=_ORG_APACHE_XML_PATH_

if defined CUSTOM_CLASSPATH set CUSTOM_CLASSPATH=;%CUSTOM_CLASSPATH%

:: rcleartool uses the CCRC_CLEARDIFF_PATH environment variable to find the diff/merge commands
if not defined CCRC_CLEARDIFF_PATH set CCRC_CLEARDIFF_PATH=_CCRC_CLEARDIFF_PATH_

if not exist "%RCLEARTOOL_HOME%" (
    echo %CMD% has not been configured. To configure, run '%CMD% setup'.
    exit /B 98
)

:: Pull in rcleartool.conf options for the java command
set INI_PATH=%PATH_TO_RCLEARTOOL%rcleartool.conf
set INI_OPTIONS=
if exist "%INI_PATH%" (
    for /f "usebackq eol= tokens=* delims=" %%x in ("%INI_PATH%") do call :processIni %%x
)

:: Execute the java command with arguments
"%_JAVACMD%" %INI_OPTIONS% -Djava.util.logging.config.file="%PATH_TO_RCLEARTOOL%/logging.properties" -cp "%JARS_DIR%\*;%RCLEARTOOL_HOME%\*;%RCLEARTOOL_HOME%;%ORG_APACHE_XML_PATH%%CUSTOM_CLASSPATH%" com.ibm.rational.ccrc.cli.RCleartool %*
exit /B %ERRORLEVEL%

:processIni
set INI_OPTIONS=%INI_OPTIONS% %*
goto :EOF
