<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">
 
 <xsl:output method="xml" indent="yes"/>  
  
  <xsl:template match="*">
    <xsl:choose>
    	<xsl:when test="local-name()='form-data-as-xml'">
    		<xsl:apply-templates select="@*|node()"/>
    	</xsl:when>
	    <xsl:when test="local-name()='dataSource'">
	    </xsl:when>
	    <xsl:when test="local-name()='definition'">
	    </xsl:when>
	    <xsl:when test="local-name()='fieldSource' or local-name()='fieldPath' or local-name()='webDependentFields'">
	    	<xsl:element name="{local-name()}">
	    		<xsl:variable name="nodeset" select="node()"/>
	    		<xsl:variable name="fieldSourceCount" select="count($nodeset)"/>
	    		<xsl:if test="$fieldSourceCount = 1">
	    			<xsl:value-of select="*:field/*[local-name()='display-name']"/>
	    		</xsl:if>
	    		<xsl:if test="$fieldSourceCount > 1">
	    			<xsl:for-each select="$nodeset">
    					<xsl:value-of select="*[local-name()='display-name']"/>
  						<xsl:if test="position() != $fieldSourceCount">
  							<xsl:text>.</xsl:text>
  						</xsl:if>
  					</xsl:for-each>
	    		</xsl:if>
	    	</xsl:element>
	    </xsl:when>
	    <xsl:otherwise>
		    <xsl:element name="{local-name()}">
		      <xsl:apply-templates select="@*|node()"/>
		    </xsl:element>
	    </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="@*">
    <xsl:attribute name="{local-name()}">
      <xsl:value-of select="."/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template match="processing-instruction()|comment()">
    <xsl:copy>
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
</xsl:stylesheet>